/*
 *	GG2Stats Message
 *	Author: WoodNeck
 *	If you having any problems, please contact me via steam:
 *	http://steamcommunity.com/id/woodneck/
 *	or E-mail:
 *	saiyu915@naver.com
 */
 
//Declaring global variables
globalvar GG2StatsM;
GG2StatsM = id;
GG2StatsM.packetID = argument1;
GG2StatsM.loginBuffer = buffer_create();
GG2StatsM.basehttp = "https://gg2statsapp.appspot.com";

//Say hello to server
object_event_add(PlayerControl,ev_create,0,"
	if !global.isHost {
		if (variable_global_exists('unique_key'))
		{
			if (global.unique_key != '')
			{
				write_ubyte(GG2StatsM.loginBuffer, 0);
				write_string(GG2StatsM.loginBuffer, global.unique_key);
				PluginPacketSend(GG2StatsM.packetID, GG2StatsM.loginBuffer);
				buffer_clear(GG2StatsM.packetID);
			}
		}
    }
");

//Create message handler instance when each player joins game
object_event_add(PlayerControl, ev_step, ev_step_begin, "
	if !instance_exists(global.gg2statsMessageHandler)
		instance_create(0,0,global.gg2statsMessageHandler);
");

//Attempts log-in to server
if !variable_global_exists('gg2statsMessageHandler')
{
	globalvar gg2statsMessageHandler;
	gg2statsMessageHandler = object_add();
	object_event_add(gg2statsMessageHandler, ev_step, ev_step_end, "
		//Host processing message
		if (global.isHost)
		{
			while(PluginPacketGetBuffer(GG2StatsM.packetID) != -1) {
				_buffer = PluginPacketGetBuffer(GG2StatsM.packetID);
				_player = PluginPacketGetPlayer(GG2StatsM.packetID);
				if (_player == -1 || !instance_exists(_player))
					break;
				switch(read_ubyte(_buffer))
				{
					//User say hello with own unique key
					case 0:
						player_key = read_string(_buffer, buffer_size(_buffer));
						httpHandler = instance_create(0, 0, gg2statsHttpHandler);
						httpHandler.http = global.basehttp + '/pointview';
						httpHandler.http_buffer = buffer_create();
						httpHandler.user_name = _player.name;
						write_string(httpHandler.http_buffer, 'user_key=' + player_key);
						with (httpHandler)
						{
							event_user(0); //do http thing
						}
				}
				buffer_clear(_buffer);
				PluginPacketPop(GG2StatsM.packetID);
			}
		}
	");
	
	//here comes the new challenger
	object_event_add(gg2statsMessageHandler, ev_other, ev_user0, "
		var message;
		player_name = ds_list_find_value(body_list, 0);
		player_rank = ds_list_find_value(body_list, 1);
		player_point = ds_list_find_value(body_list, 2);
		message = string(player_name) + ' came to server(GG2S-rank: ' + string(player_rank) + ', point: ' +  string(player_point) + ')';
		ServerMessageString(message,global.sendBuffer);
		with NoticeO instance_destroy();
		notice = instance_create(0, 0, NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = message;
		alarm[0] = 90/global.delta_factor;
	");
	
	//and his hello message
	object_event_add(gg2statsMessageHandler, ev_alarm, 0, "
		var message;
		player_name = ds_list_find_value(body_list, 0);
		player_message = ds_list_find_value(body_list, 3);
		message = string(player_name) + ' says: ' + string(player_message);
		ServerMessageString(message,global.sendBuffer);
		with NoticeO instance_destroy();
		notice = instance_create(0, 0, NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = message;
		ds_list_destroy(body_list);
	");
	
}

//Http Handler
if !variable_global_exists('httpHandler')
{
	globalvar gg2statsHttpHandler;
	gg2statsHttpHandler = object_add();
	object_event_add(gg2statsHttpHandler, ev_step, ev_step_begin, "
		if (working)
		{
			//if http page load has done
			if(http_step(connection))
			{
				working = false;
				// page loaded well with code 200
				if (http_status_code(connection) == 200)
				{
					body_str = read_string(http_response_body(connection), http_response_body_size(connection));
					http_destroy(connection);
					if (body_str != '')//if load fails, page just send out blank page
					{
						body_list = split(body_str, ',');
						ds_list_insert(body_list, 0, user_name);
						gg2statsMessageHandler.body_list = body_list;
						with (gg2statsMessageHandler)
						{
							event_user(0); //do notice thing
						}
					}
				}
			}
		}
	");
	
	object_event_add(gg2statsHttpHandler, ev_other, ev_user0, "
		connection = http_new_post(http, http_buffer, 'application/x-www-form-urlencoded');
		working = true;
	");
}